import numpy, cv2

def on_mouse(event, x, y, flags, param):
    if event == cv2.EVENT_MOUSEMOVE:
        l = F.dot(numpy.array((x,y,1)))
        w = img1.shape[1]
        img1c = img1.copy()
        cv2.line(img1c, (0,int(-l[2]/l[1])),\
                 (w,int((-l[2]-l[0]*w)/l[1])), (0,0,255))
        cv2.imshow('Image 1', img1c)

cv2.namedWindow('Image 0')
cv2.setMouseCallback('Image 0', on_mouse)

img0 = cv2.imread('img0.png')
img1 = cv2.imread('img1.png')
img1c = img1.copy()
F = numpy.loadtxt('fundM.txt')
cv2.imshow('Image 0', img0)
cv2.imshow('Image 1', img1c)

while 1:
    key = cv2.waitKey(10)

    if key == 0x1b: # ESC
        break

