M=load('M.txt');
mask=load('mask.txt');
% for i=1:10
%     good_pts=find(sum(mask,2)>4);
%     M=M(good_pts,:);
%     mask=mask(good_pts,:);
%     good_view=find(sum(mask,1)>4);
%     M=M(:,good_view);
%     mask=mask(:,good_view);
% end

%[U,V] = damped_wiberg(M,mask,4);

poses = size(M,2)/2;
n=1;
A = zeros(poses*n,6);
for i=1:poses
    rx = V((i-1)*2+1,1:3);
    ry = V((i-1)*2+2,1:3);
    A((i-1)*n+1,1) = rx(1)*ry(1);
    A((i-1)*n+1,2) = rx(1)*ry(2)+rx(2)*ry(1);
    A((i-1)*n+1,3) = rx(1)*ry(3)+rx(3)*ry(1);
    A((i-1)*n+1,4) = rx(2)*ry(2);
    A((i-1)*n+1,5) = rx(2)*ry(3)+rx(3)*ry(2);
    A((i-1)*n+1,6) = rx(3)*ry(3);
    
    A((i-1)*2+2,1) = rx(1)*rx(1)-ry(1)*ry(1);
    A((i-1)*2+2,2) = 2*(rx(1)*rx(2)-ry(1)*ry(2));
    A((i-1)*2+2,3) = 2*(rx(1)*rx(3)-ry(1)*ry(3));
    A((i-1)*2+2,4) = rx(2)*rx(2)-ry(2)*ry(2);
    A((i-1)*2+2,5) = 2*(rx(2)*rx(3)-ry(2)*ry(3));
    A((i-1)*2+2,6) = rx(3)*rx(3)-ry(3)*ry(3);
    
%     p = mod(i, poses)+1;
%     ry = V((p-1)*2+1,1:3);
%     A((i-1)*3+3,1) = rx(1)*rx(1)-ry(1)*ry(1);
%     A((i-1)*3+3,2) = rx(1)*rx(2)-ry(1)*ry(2);
%     A((i-1)*3+3,3) = rx(1)*rx(3)-ry(1)*ry(3);
%     A((i-1)*3+3,4) = rx(2)*rx(2)-ry(2)*ry(2);
%     A((i-1)*3+3,5) = rx(2)*rx(3)-ry(2)*ry(3);
%     A((i-1)*3+3,6) = rx(3)*rx(3)-ry(3)*ry(3);
%     A((i-1)*2+1,1) = rx(1)*ry(1);
%     A((i-1)*2+1,2) = rx(1)*ry(2);
%     A((i-1)*2+1,3) = rx(1)*ry(3);
%     A((i-1)*2+1,4) = rx(2)*ry(1);
%     A((i-1)*2+1,5) = rx(2)*ry(2);
%     A((i-1)*2+1,6) = rx(2)*ry(3);
%     A((i-1)*2+1,7) = rx(3)*ry(1);
%     A((i-1)*2+1,8) = rx(3)*ry(2);
%     A((i-1)*2+1,9) = rx(3)*ry(3);
%     A((i-1)*2+2,1) = rx(1)*rx(1)-ry(1)*ry(1);
%     A((i-1)*2+2,2) = rx(1)*rx(2)-ry(1)*ry(2);
%     A((i-1)*2+2,3) = rx(1)*rx(3)-ry(1)*ry(3);
%     A((i-1)*2+2,4) = rx(2)*rx(1)-ry(2)*ry(1);
%     A((i-1)*2+2,5) = rx(2)*rx(2)-ry(2)*ry(2);
%     A((i-1)*2+2,6) = rx(2)*rx(3)-ry(2)*ry(3);
%     A((i-1)*2+2,7) = rx(3)*rx(1)-ry(3)*ry(1);
%     A((i-1)*2+2,8) = rx(3)*rx(2)-ry(3)*ry(2);
%     A((i-1)*2+2,9) = rx(3)*rx(3)-ry(3)*ry(3);
end
   
[Au,Aw,Av] = svd(A);
HtH=[Av(1,6),Av(2,6),Av(3,6);Av(2,6),Av(4,6),Av(5,6);Av(3,6),Av(5,6),Av(6,6)];
e=eig(HtH);
if e < 0,
    HtH = -HtH
end
K=chol(HtH);
V2=V(:,1:3)*K';

rot=cell(poses,1);
for i=1:poses
    rot{i}=zeros(3,3);
    rot{i}(1,:)=V2((i-1)*2+1,:)/norm(V2((i-1)*2+1,:));
    rot{i}(2,:)=V2((i-1)*2+2,:)/norm(V2((i-1)*2+2,:));
    rot{i}(3,:)=cross(rot{i}(1,:),rot{i}(2,:));
end

campos=zeros(poses,3);
for i=1:poses
    campos(i,:) = (rot{i}*[mu((i-1)*2+1),mu((i-1)*2+2),-100]')';
end