import numpy, cv2

def decompose_E(E):
    U, s, Vt = numpy.linalg.svd(E)
    print 'singluar value = ', s
    #print U.dot(numpy.diag(s)).dot(Vt), E
    W = numpy.array([[0,-1,0],[1,0,0],[0,0,1]])
    R0=U.dot(W).dot(Vt) # UWVt
    R1=U.dot(W.transpose()).dot(Vt) # UWVt
    if numpy.linalg.det(R0) < 0:
        R0=U.dot(-W).dot(Vt) #
        R1=U.dot(-W.transpose()).dot(Vt)
    t=U[:,2] # u3
    Rt_list=((R0,t),(R0,-t),(R1,t),(R1,-t))
    return Rt_list

if __name__=="__main__":
    F = numpy.loadtxt('fundM.txt')
    K = numpy.loadtxt('K.txt')
    E = (K.transpose().dot(F)).dot(K)
    Rt_list = decompose_E(E)
    print Rt_list

