import numpy, cv2, decompE

F = numpy.loadtxt('fundM.txt')
K = numpy.loadtxt('K.txt')
pts0 = numpy.loadtxt('pts0.txt').transpose()
pts1 = numpy.loadtxt('pts1.txt').transpose()

E = (K.transpose().dot(F)).dot(K)
Rt_list = decompE.decompose_E(E)
#print Rt_list
P0 = numpy.array([[1,0,0,0],[0,1,0,0],[0,0,1,0]])
P0 = K.dot(P0)
for i in range(4):
    P1c = numpy.zeros((3,4))
    P1c[0:3,0:3] = Rt_list[i][0]
    #print 'detR=', numpy.linalg.det(Rt_list[i][0])
    P1c[:,3] = Rt_list[i][1]
    P1 = K.dot(P1c)
    print 'P1=', P1
    pts3d = cv2.triangulatePoints(P0, P1, pts0, pts1)
    pts3d = pts3d/pts3d[3,:] # normalize 
    pts3d_1 = P1c.dot(pts3d) # X'=RX+t
    print i
    print 'depth0 =', numpy.median(pts3d[2,:])
    print 'depth1 =', numpy.median(pts3d_1[2,:])
    if i==0:
        numpy.savetxt('pts3d.txt', pts3d[:3,:].T)
